package org.jvnet.hypercompass.compass.mapping;

import org.jvnet.hypercompass.compass.mapping.strategy.NamingStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.jaxbcommons.util.CodeModelUtils;

import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.generator.PackageContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class DefaultNamingStrategy implements NamingStrategy {

	private PrincipalStrategy principalStrategy;

	public PrincipalStrategy getPrincipalStrategy() {
		return principalStrategy;
	}

	public DefaultNamingStrategy(PrincipalStrategy principalStrategy) {
		this.principalStrategy = principalStrategy;
	}

	public String getRefAlias(ClassContext classContext) {

		final String packagePrefix = getPrincipalStrategy().getNamingStrategy()
				.getPackagePrefix(classContext._package);

		final String classAlias = "[" + packagePrefix
				+ CodeModelUtils.getLocalClassName(classContext.ref) + "]";

		return classAlias;
	}

	public String getImplAlias(ClassContext classContext) {

		final String packagePrefix = getPrincipalStrategy().getNamingStrategy()
				.getPackagePrefix(classContext._package);

		final String classAlias = packagePrefix
				+ CodeModelUtils.getLocalClassName(classContext.ref);

		return classAlias;
	}

	public String getImplName(ClassContext classContext) {

		return CodeModelUtils.getClassName(classContext.implClass);
	}

	public String getPackagePrefix(PackageContext packageContext) {
		return packageContext._package.name() + ".";
	}

	public String getDefaultMetaDataAlias(ClassContext classContext,
			FieldItem fieldItem) {
		final String classAlias = getPrincipalStrategy().getNamingStrategy()
				.getImplAlias(classContext);
		final String defaultMetaData = classAlias + "." + fieldItem.name;
		return defaultMetaData;
	}
}
