package org.jvnet.hypercompass.compass.mapping.strategy;

import org.compass.core.converter.ConverterLookup;
import org.compass.core.converter.DefaultConverterLookup;
import org.jvnet.hypercompass.compass.mapping.DefaultNamingStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.clazz.DefaultClassStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.clazz.DefaultSubclassStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.CompassCoreMappingStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.ComponentStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.IdStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.MetaDataStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.PropertyStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.compassmapping.ReferenceStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.ComplexCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.DomCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.EnumCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.HeteroCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.PrimitiveCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.collection.WildcardCollectionFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.ComplexSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.DomSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.EnumSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.HeteroSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.PrimitiveSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.field.single.WildcardSingleFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.fields.FieldsStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.identifier.DefaultIdentifierStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.visitor.VisitorStrategy;

public class DefaultPrincipalStrategy implements PrincipalStrategy {

	private NamingStrategy namingStrategy = new DefaultNamingStrategy(this);

	public NamingStrategy getNamingStrategy() {
		return namingStrategy;
	}

	public void setNamingStrategy(NamingStrategy namingStrategy) {
		this.namingStrategy = namingStrategy;
	}

	private ClassStrategy compassCoreMappingStrategy = new CompassCoreMappingStrategy(
			this);

	public ClassStrategy getCompassCoreMappingStrategy() {
		return compassCoreMappingStrategy;
	}

	public void setCompassCoreMappingStrategy(
			ClassStrategy compassCoreMappingStrategy) {
		this.compassCoreMappingStrategy = compassCoreMappingStrategy;
	}

	private FieldStrategy idStrategy = new IdStrategy(this);

	public FieldStrategy getIdStrategy() {
		return idStrategy;
	}

	public void setIdStrategy(FieldStrategy idStrategy) {
		this.idStrategy = idStrategy;
	}

	private FieldStrategy propertyStrategy = new PropertyStrategy(this);

	public FieldStrategy getPropertyStrategy() {
		return propertyStrategy;
	}

	public void setPropertyStrategy(FieldStrategy propertyStrategy) {
		this.propertyStrategy = propertyStrategy;
	}

	private FieldStrategy componentStrategy = new ComponentStrategy(this);

	public FieldStrategy getComponentStrategy() {
		return componentStrategy;
	}

	public void setComponentStrategy(FieldStrategy componentStrategy) {
		this.componentStrategy = componentStrategy;
	}

	private FieldStrategy referenceStrategy = new ReferenceStrategy(this);

	public FieldStrategy getReferenceStrategy() {
		return referenceStrategy;
	}

	public void setReferenceStrategy(FieldStrategy referenceStrategy) {
		this.referenceStrategy = referenceStrategy;
	}

	private FieldStrategy metaDataStrategy = new MetaDataStrategy(this);

	public FieldStrategy getMetaDataStrategy() {
		return metaDataStrategy;
	}

	public void setMetaDataStrategy(FieldStrategy metaDataStrategy) {
		this.metaDataStrategy = metaDataStrategy;
	}

	private ClassStrategy classStrategy = new DefaultClassStrategy(this);

	public ClassStrategy getClassStrategy() {
		return classStrategy;
	}

	public void setClassStrategy(ClassStrategy classStrategy) {
		this.classStrategy = classStrategy;
	}

	private ClassStrategy subclassStrategy = new DefaultSubclassStrategy(this);

	public ClassStrategy getSubclassStrategy() {
		return subclassStrategy;
	}

	public void setSubclassStrategy(ClassStrategy subclassStrategy) {
		this.subclassStrategy = subclassStrategy;
	}

	private FieldStrategy primitiveSingleStrategy = new PrimitiveSingleFieldStrategy(
			this);

	public FieldStrategy getPrimitiveSingleStrategy() {
		return primitiveSingleStrategy;
	}

	public void setPrimitiveSingleStrategy(FieldStrategy primitiveSingleStrategy) {
		this.primitiveSingleStrategy = primitiveSingleStrategy;
	}

	private FieldStrategy enumSingleStrategy = new EnumSingleFieldStrategy(this);

	public FieldStrategy getEnumSingleStrategy() {
		return enumSingleStrategy;
	}

	public void setEnumSingleStrategy(FieldStrategy enumSingleStrategy) {
		this.enumSingleStrategy = enumSingleStrategy;
	}

	private FieldStrategy domSingleStrategy = new DomSingleFieldStrategy(this);

	public FieldStrategy getDomSingleStrategy() {
		return domSingleStrategy;
	}

	public void setDomSingleStrategy(FieldStrategy domSingleStrategy) {
		this.domSingleStrategy = domSingleStrategy;
	}

	private FieldStrategy complexSingleStrategy = new ComplexSingleFieldStrategy(
			this);

	public FieldStrategy getComplexSingleStrategy() {
		return complexSingleStrategy;
	}

	public void setComplexSingleStrategy(FieldStrategy complexSingleStrategy) {
		this.complexSingleStrategy = complexSingleStrategy;
	}

	private FieldStrategy wildcardSingleStrategy = new WildcardSingleFieldStrategy(
			this);

	public FieldStrategy getWildcardSingleStrategy() {
		return wildcardSingleStrategy;
	}

	public void setWildcardSingleStrategy(FieldStrategy wildcardSingleStrategy) {
		this.wildcardSingleStrategy = wildcardSingleStrategy;
	}

	private FieldStrategy heteroSingleStrategy = new HeteroSingleFieldStrategy(
			this);

	public FieldStrategy getHeteroSingleStrategy() {
		return heteroSingleStrategy;
	}

	public void setHeteroSingleStrategy(FieldStrategy heteroSingleStrategy) {
		this.heteroSingleStrategy = heteroSingleStrategy;
	}

	private FieldStrategy primitiveCollectionStrategy = new PrimitiveCollectionFieldStrategy(
			this);

	public FieldStrategy getPrimitiveCollectionStrategy() {
		return primitiveCollectionStrategy;
	}

	public void setPrimitiveCollectionStrategy(
			FieldStrategy primitiveCollectionStrategy) {
		this.primitiveCollectionStrategy = primitiveCollectionStrategy;
	}

	private FieldStrategy enumCollectionStrategy = new EnumCollectionFieldStrategy(
			this);

	public FieldStrategy getEnumCollectionStrategy() {
		return enumCollectionStrategy;
	}

	public void setEnumCollectionStrategy(FieldStrategy enumCollectionStrategy) {
		this.enumCollectionStrategy = enumCollectionStrategy;
	}

	private FieldStrategy domCollectionStrategy = new DomCollectionFieldStrategy(
			this);

	public FieldStrategy getDomCollectionStrategy() {
		return domCollectionStrategy;
	}

	public void setDomCollectionStrategy(FieldStrategy domCollectionStrategy) {
		this.domCollectionStrategy = domCollectionStrategy;
	}

	private FieldStrategy complexCollectionStrategy = new ComplexCollectionFieldStrategy(
			this);

	public FieldStrategy getComplexCollectionStrategy() {
		return complexCollectionStrategy;
	}

	public void setComplexCollectionStrategy(
			FieldStrategy complexCollectionStrategy) {
		this.complexCollectionStrategy = complexCollectionStrategy;
	}

	private FieldStrategy wildcardCollectionStrategy = new WildcardCollectionFieldStrategy(
			this);

	public FieldStrategy getWildcardCollectionStrategy() {
		return wildcardCollectionStrategy;
	}

	public void setWildcardCollectionStrategy(
			FieldStrategy wildcardCollectionStrategy) {
		this.wildcardCollectionStrategy = wildcardCollectionStrategy;
	}

	private FieldStrategy heteroCollectionStrategy = new HeteroCollectionFieldStrategy(
			this);

	public FieldStrategy getHeteroCollectionStrategy() {
		return heteroCollectionStrategy;
	}

	public void setHeteroCollectionStrategy(
			FieldStrategy heteroCollectionStrategy) {
		this.heteroCollectionStrategy = heteroCollectionStrategy;
	}

	private ClassStrategy fieldsStrategy = new FieldsStrategy(this);

	public ClassStrategy getFieldsStrategy() {
		return fieldsStrategy;
	}

	public void setFieldsStrategy(ClassStrategy fieldsStrategy) {
		this.fieldsStrategy = fieldsStrategy;
	}

	private ClassStrategy visitorStrategy = new VisitorStrategy(this);

	public ClassStrategy getVisitorStrategy() {
		return visitorStrategy;
	}

	public void setVisitorStrategy(ClassStrategy visitorStrategy) {
		this.visitorStrategy = visitorStrategy;
	}

	private ClassStrategy identifierStrategy = new DefaultIdentifierStrategy(
			this);

	public ClassStrategy getIdentifierStrategy() {
		return identifierStrategy;
	}

	public void setIdentifierStrategy(ClassStrategy identifierStrategy) {
		this.identifierStrategy = identifierStrategy;
	}

	private ConverterLookup converterLookup = new DefaultConverterLookup();

	public ConverterLookup getConverterLookup() {
		return converterLookup;
	}

	public void setConverterLookup(ConverterLookup converterLookup) {
		this.converterLookup = converterLookup;
	}

}