package org.jvnet.hypercompass.compass.mapping.strategy.clazz;

import java.util.Iterator;
import java.util.List;

import javax.xml.bind.Element;

import org.jvnet.hypercompass.compass.mapping.Clazz;
import org.jvnet.hypercompass.compass.mapping.CompassCoreMapping;
import org.jvnet.hypercompass.compass.mapping.Contract;
import org.jvnet.hypercompass.compass.mapping.impl.ClazzImpl;
import org.jvnet.hypercompass.compass.mapping.impl.ContractImpl;
import org.jvnet.hypercompass.compass.mapping.strategy.AbstractClassStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.jaxbcommons.util.ClassUtils;
import org.jvnet.jaxbcommons.util.CodeModelUtils;

import com.sun.tools.xjc.generator.ClassContext;

public class DefaultSubclassStrategy extends AbstractClassStrategy {

  public DefaultSubclassStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  public Object generate(ClassContext classContext) {

    final CompassCoreMapping compassCoreMapping = (CompassCoreMapping) getPrincipalStrategy()
        .getCompassCoreMappingStrategy()
        .generate(classContext);

    final Contract contract;
    {
      contract = new ContractImpl();
      contract.setAlias(getPrincipalStrategy().getNamingStrategy().getRefAlias(classContext));

      final List fieldMappings = (List) getPrincipalStrategy().getFieldsStrategy().generate(
          classContext);

      for (Iterator iterator = fieldMappings.iterator(); iterator.hasNext();) {
        final Object fieldMapping = (Object) iterator.next();
        if (fieldMapping != null) {
          contract.getContent().add(fieldMapping);
        }
      }
    }
    compassCoreMapping.getContent().add(contract);

    final Clazz clazz;
    {
      clazz = new ClazzImpl();
      final String implClassName = CodeModelUtils.getClassName(classContext.implClass);
      clazz.setName(implClassName);

      clazz.setRoot("false");

      // final ClassItem classItem = classContext.target;
      // final ClassItem superClassItem = classItem.getSuperClass();
      // final ClassContext superClassContext =
      // classContext.parent.getClassContext(superClassItem);
      // clazz.setExtends(getPrincipalStrategy().getNamingStrategy().getRefAlias(superClassContext)
      // + ","
      // +
      // getPrincipalStrategy().getNamingStrategy().getRefAlias(classContext));

      final StringBuffer extendedAliases = new StringBuffer();
      final List ancestors = ClassUtils.getAncestorsAndSelf(classContext);
      for (Iterator iterator = ancestors.iterator(); iterator.hasNext();) {
        final ClassContext extendedClassContext = (ClassContext) iterator.next();
        extendedAliases.append(getPrincipalStrategy().getNamingStrategy().getRefAlias(
            extendedClassContext));
        if (iterator.hasNext()) {
          extendedAliases.append(',');
        }
      }
      clazz.setExtends(extendedAliases.toString());
      clazz.setAlias(getPrincipalStrategy().getNamingStrategy().getImplAlias(classContext));

      // Id
      // {
      // final Object id =
      // getPrincipalStrategy().getIdentifierStrategy().generate(classContext);
      // clazz.getContent().add(id);
      // }
    }

    compassCoreMapping.getContent().add(clazz);
    return compassCoreMapping;
  }

}
