package org.jvnet.hypercompass.compass.mapping.strategy.compassmapping;

import org.jvnet.hypercompass.compass.mapping.Component;
import org.jvnet.hypercompass.compass.mapping.Property;
import org.jvnet.hypercompass.compass.mapping.impl.ComponentImpl;
import org.jvnet.hypercompass.compass.mapping.impl.PropertyImpl;
import org.jvnet.hypercompass.compass.mapping.strategy.AbstractFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.jaxbcommons.util.CodeModelUtils;
import org.jvnet.jaxbcommons.util.FieldUtils;
import org.jvnet.jaxbcommons.util.TypeUtils;

import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;

public class ComponentStrategy extends AbstractFieldStrategy {

  public ComponentStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  public Object generate(ClassContext classContext, FieldItem fieldItem) {

    final Component component = new ComponentImpl();

    final String propertyName = FieldUtils.getFieldPropertyName(fieldItem);
    component.setName(propertyName);

    final ClassItem fieldClassItem = (ClassItem) TypeUtils.getCommonBaseTypeItem(
        classContext,
        fieldItem);

    final ClassContext fieldClassContext = classContext.parent.getClassContext(fieldClassItem);

    final String refAlias = getPrincipalStrategy().getNamingStrategy().getImplAlias(
        fieldClassContext);
    component.setRefAlias(refAlias);

    return component;
  }

}
