package org.jvnet.hypercompass.compass.mapping.strategy.compassmapping;

import org.jvnet.hypercompass.compass.mapping.Id;
import org.jvnet.hypercompass.compass.mapping.MetaData;
import org.jvnet.hypercompass.compass.mapping.impl.IdImpl;
import org.jvnet.hypercompass.compass.mapping.strategy.AbstractFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.hypercompass.runtime.compass.accessor.CheckingAccessor;
import org.jvnet.hypercompass.runtime.compass.accessor.CheckingPropertyAccessor;
import org.jvnet.jaxbcommons.util.FieldUtils;

import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class IdStrategy extends AbstractFieldStrategy {

  public IdStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  public Object generate(ClassContext classContext, FieldItem fieldItem) {

    final Id id = new IdImpl();

    final String propertyName = FieldUtils.getFieldPropertyName(fieldItem);

    id.setName(propertyName);
    id.setManagedId("false");
    id.setAccessor(CheckingPropertyAccessor.class.getName());

    final MetaData[] metaDataArray = (MetaData[]) getPrincipalStrategy()
        .getMetaDataStrategy()
        .generate(classContext, fieldItem);

    if (metaDataArray != null) {
      for (int index = 0; index < metaDataArray.length; index++) {
        final MetaData metaData = metaDataArray[index];
        if (index == 0) {
          metaData.setStore("yes");
          metaData.setIndex("un_tokenized");
        }
        id.getMetaData().add(metaData);
      }
    }

    return id;
  }

}
