package org.jvnet.hypercompass.compass.mapping.strategy.compassmapping;

import org.jvnet.hypercompass.compass.mapping.MetaData;
import org.jvnet.hypercompass.compass.mapping.impl.MetaDataImpl;
import org.jvnet.hypercompass.compass.mapping.strategy.AbstractFieldStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.hypercompass.customizations.MetaDataType;
import org.jvnet.hypercompass.customizations.Utils;

import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class MetaDataStrategy extends AbstractFieldStrategy {

  public MetaDataStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  public Object generate(ClassContext classContext, FieldItem fieldItem) {

    final MetaDataType[] metaData = Utils.getMetaData(fieldItem);

    final MetaData defaultMetaData = new MetaDataImpl();
    defaultMetaData.setStore("no");
    final String metaDataContent = getPrincipalStrategy().getNamingStrategy().getDefaultMetaDataAlias(
        classContext,
        fieldItem);
    defaultMetaData.setContent(metaDataContent);

    if (metaData == null || metaData.length < 1) {
      return new MetaData[]{ defaultMetaData };
    }
    else {
      final MetaData[] mdArray = new MetaData[metaData.length + 1];
      mdArray[0] = defaultMetaData;
      for (int index = 0; index < metaData.length; index++) {
        final MetaDataType cmetaData = metaData[index];
        final MetaData md = new MetaDataImpl();
        if (cmetaData.isSetStore()) {
          md.setStore(cmetaData.getStore());
        }
        else {
          md.setStore("yes");
        }
        if (cmetaData.isSetIndex()) {
          md.setIndex(cmetaData.getIndex());
        }
        if (cmetaData.isSetTermVector()) {
          md.setTermVector(cmetaData.getTermVector());
        }
        if (cmetaData.isSetReverse()) {
          md.setReverse(cmetaData.getReverse());
        }
        if (cmetaData.isSetAnalyzer()) {
          md.setAnalyzer(cmetaData.getAnalyzer());
        }
        if (cmetaData.isSetExcludeFromAll()) {
          md.setExcludeFromAll(cmetaData.getExcludeFromAll());
        }
        if (cmetaData.isSetConverter()) {
          md.setConverter(cmetaData.getConverter());
        }
        if (cmetaData.isSetBoost()) {
          md.setBoost(cmetaData.getBoost());
        }
        if (cmetaData.isSetAlias()) {
          md.setContent(cmetaData.getAlias());
        }
        mdArray[index + 1] = md;
      }
      return mdArray;
    }
  }
}
