package org.jvnet.hypercompass.compass.mapping.strategy.field.single;

import org.jvnet.hypercompass.compass.mapping.Component;
import org.jvnet.hypercompass.compass.mapping.Reference;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.hypercompass.customizations.Constants;
import org.jvnet.hypercompass.runtime.compass.accessor.CheckingPropertyAccessor;
import org.jvnet.jaxbcommons.util.CustomizationUtils;
import org.jvnet.jaxbcommons.util.TypeUtils;

import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;

public class AbstractComplexSingleFieldStrategy extends AbstractSingleFieldStrategy {

  public AbstractComplexSingleFieldStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  protected AbstractComplexSingleFieldStrategy() {
    super();
  }

  public Object generate(ClassContext classContext, FieldItem fieldItem) {

    final ClassItem fieldClassItem = (ClassItem) TypeUtils.getCommonBaseTypeItem(
        classContext,
        fieldItem);

    if (CustomizationUtils.ancestorOrSelfContainsCustomization(fieldClassItem, Constants.COMPONENT)) {
      return generateComponent(classContext, fieldItem);

    }
    else if (CustomizationUtils.ancestorOrSelfContainsCustomization(
        fieldClassItem,
        Constants.REFERENCE)) {
      return generateReference(classContext, fieldItem);
    }
    else {
      return generateDefault(classContext, fieldItem);
    }
  }

  protected Object generateDefault(ClassContext classContext, FieldItem fieldItem) {
    return null;
  }

  protected Object generateReference(ClassContext classContext, FieldItem fieldItem) {
    final Reference reference = (Reference) getPrincipalStrategy().getReferenceStrategy().generate(
        classContext,
        fieldItem);
    reference.setAccessor(CheckingPropertyAccessor.class.getName());
    return reference;
  }

  protected Object generateComponent(ClassContext classContext, FieldItem fieldItem) {
    final Component component = (Component) getPrincipalStrategy().getComponentStrategy().generate(
        classContext,
        fieldItem);
    component.setAccessor(CheckingPropertyAccessor.class.getName());
    return component;
  }
}
