package org.jvnet.hypercompass.compass.mapping.strategy.field.single;

import org.jvnet.hypercompass.compass.mapping.MetaData;
import org.jvnet.hypercompass.compass.mapping.Property;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.hypercompass.runtime.compass.accessor.CheckingPropertyAccessor;
import org.jvnet.jaxbcommons.util.TypeUtils;

import com.sun.codemodel.JType;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;
import com.sun.tools.xjc.grammar.PrimitiveItem;

public abstract class AbstractSimpleSingleFieldStrategy extends AbstractSingleFieldStrategy {

  public AbstractSimpleSingleFieldStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  protected AbstractSimpleSingleFieldStrategy() {
    super();
  }

  public Object generate(ClassContext classContext, FieldItem fieldItem) {

    final Property property = (Property) getPrincipalStrategy().getPropertyStrategy().generate(
        classContext,
        fieldItem);
    property.setAccessor(CheckingPropertyAccessor.class.getName());
    
    
    final PrimitiveItem item = TypeUtils.getPrimitiveItem(fieldItem);
    final JType type = item.getType();
    final String className = type.fullName();
    property.setClassName(className);

    final String converterName = getConverterName(classContext, fieldItem);
    final MetaData[] metaDataArray = (MetaData[]) getPrincipalStrategy()
        .getMetaDataStrategy()
        .generate(classContext, fieldItem);

    if (metaDataArray != null) {
      for (int index = 0; index < metaDataArray.length; index++) {
        final MetaData metaData = metaDataArray[index];
        if (metaData.getConverter() == null) {
          metaData.setConverter(converterName);
        }
        property.getMetaData().add(metaData);
      }
    }

    return property;
  }

  protected abstract String getConverterName(ClassContext classContext, FieldItem fieldItem);

}
