package org.jvnet.hypercompass.compass.mapping.strategy.fields;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jvnet.hypercompass.compass.mapping.strategy.AbstractClassStrategy;
import org.jvnet.hypercompass.compass.mapping.strategy.PrincipalStrategy;
import org.jvnet.hypercompass.customizations.Constants;
import org.jvnet.jaxbcommons.util.CustomizationUtils;
import org.jvnet.jaxbcommons.util.FieldUtils;

import com.sun.msv.grammar.ExpressionVisitor;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;
import com.sun.tools.xjc.grammar.FieldUse;

public class FieldsStrategy extends AbstractClassStrategy {

  public FieldsStrategy(PrincipalStrategy principalStrategy) {
    super(principalStrategy);
  }

  public Object generate(ClassContext classContext) {
    final ClassItem classItem = classContext.target;
    final FieldUse[] fieldUses = classItem.getDeclaredFieldUses();

    final List fieldMappings = new ArrayList();

    final List fieldItems = new ArrayList(fieldUses.length);

    for (int index = 0; index < fieldUses.length; index++) {
      final FieldUse fieldUse = fieldUses[index];
      final FieldItem fieldItem = FieldUtils.getFieldItem(fieldUse);

      if (!CustomizationUtils.containsCustomization(fieldItem, Constants.HYPERJAXB2_ID)
          && !CustomizationUtils.containsCustomization(fieldItem, Constants.ID)) {
        fieldItems.add(fieldItem);
      }
    }

    for (Iterator iterator = fieldItems.iterator(); iterator.hasNext();) {
      final FieldItem fieldItem = (FieldItem) iterator.next();

      final ExpressionVisitor visitor = (ExpressionVisitor) getPrincipalStrategy()
          .getVisitorStrategy()
          .generate(classContext);
      final Object fieldMapping = fieldItem.visit(visitor);
      if (fieldMapping != null) {
        fieldMappings.add(fieldMapping);
      }
    }
    return fieldMappings;
  }
}
