package org.jvnet.hypercompass.compass.mapping.utils;

import java.io.File;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import net.sf.saxon.TransformerFactoryImpl;

import org.jvnet.hypercompass.compass.configuration.CompassCoreConfiguration;
import org.jvnet.hypercompass.compass.mapping.CompassConfigurationConstants;

public class CompassConfigurationUtils {

	private static final JAXBContext CONTEXT;
	static {
		try {
			CONTEXT = JAXBContext.newInstance(
					CompassConfigurationConstants.JAXB_PACKAGE_NAMES,
					CompassCoreConfiguration.class.getClassLoader());
			// new ClassLoader() {
			// private ClassLoader classLoader =
			// Thread.currentThread().getContextClassLoader();
			//
			// public InputStream getResourceAsStream(String name) {
			// System.out.println(name);
			// return classLoader.getResourceAsStream(name);
			// }
			// });
		} catch (JAXBException jaxbex) {
			throw new ExceptionInInitializerError(jaxbex);
		}
	}

	private static final TransformerFactory TRANSFORMER_FACTORY;
	static {
		System.setProperty("javax.xml.transform.TransformerFactory",
				TransformerFactoryImpl.class.getName());
		TRANSFORMER_FACTORY = TransformerFactory.newInstance();
	}

	public static void marshall(Object hibernateMappingObject, File file)
			throws JAXBException, TransformerConfigurationException,
			TransformerException {
		final Marshaller marshaller = CONTEXT.createMarshaller();
		final DOMResult result = new DOMResult();
		marshaller.marshal(hibernateMappingObject, result);

		final Transformer transformer = TRANSFORMER_FACTORY.newTransformer();

		transformer.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC,
				CompassConfigurationConstants.DOCTYPE_PUBLIC);
		transformer.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM,
				CompassConfigurationConstants.DOCTYPE_SYSTEM);
		transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
		transformer.setOutputProperty(OutputKeys.INDENT, "yes");
		transformer.setOutputProperty(OutputKeys.METHOD, "xml");

		transformer.transform(new DOMSource(result.getNode()),
				new StreamResult(file));
	}

}
